//DotPicEffect
//--------------------------------------------
// Œl(͕ύX͂Ȃŉ)
//--------------------------------------------
#define		SAFE		(0.0001)
#define		ON			(1)
#define		OFF			(0)

//--------------------------------------------
// ύX\Ȑݒl
//--------------------------------------------
// o͉ʃTCY
//		o̓TCY킹鎖ŁAҏWo̓C[Wɋߎ\܂
static float2	OutputScreenSize = {512, 384};

// Phbg̃TCY
#define		DOT_SIZE	(8)

// ֊s擾͈
//		xɂ鍕͈
#define		LINE_RANGE	(0.1)

// WM
//		ON	:⊮hbg
//		OFF	:⊮hbgȂ
#define 	J_FLAG		ON

// JhbgTCY
//		ON	:JɂhbgTCYύX(DOT_SIZE * Tr * J)
//		OFF	:hbgTCYŒ(DOT_SIZE * Tr)
//				:p[Xɂ鉓߂͔fȂ
//					 S_ΏۂOĂ
//					 ܂Ȃ̂lĎgpĂ
#define		AUTO_FLG	OFF

//--------------------------------------------
// 牺͂킩Ȃl͂Ȃ
//--------------------------------------------
float Script : STANDARDSGLOBAL <
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;

//JW
float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float4x4 World      : WORLD;

// @ϊs
float4 MaterialDiffuse  : DIFFUSE  < string Object = "Geometry"; >;
float Scaling : CONTROLOBJECT < string name = "DotPict(512x384).x"; >;
//float TrNum : CONTROLOBJECT < string name = "DotPict(512x384).x";  string item = "Tr";>;

float2 ScreenSize : VIEWPORTPIXELSIZE;
static float2 DotSize = OutputScreenSize / (DOT_SIZE * MaterialDiffuse.a + SAFE);
static float2	SampStep = (1.0 / ScreenSize);
static float2 ScreenOffset = (float2(0.5,0.5)/ScreenSize);
static float ColorCount = Scaling / 10.0;


// _O^[Qbg̃NAl
float4 ClearColor = {1,1,1,1};
float ClearDepth  = 1.0;

// IWi̕`挋ʂL^邽߂̃_[^[Qbg
texture2D ScnMap : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 10;
    string Format = "A8R8G8B8" ;
>;

sampler2D ScnSamp = sampler_state {
    texture = <ScnMap>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

// HSV摜̃_[^[Qbg
texture2D ScnMapHSV : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0, 1.0};
    int MipLevels = 1;
    string Format = "A8R8G8B8" ;
>;
sampler2D ScnSampHSV = sampler_state {
    texture = <ScnMapHSV>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

// F摜̃_[^[Qbg
texture2D ScnMapColS : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0, 1.0};
    int MipLevels = 1;
    string Format = "A8R8G8B8" ;
>;
sampler2D ScnSampColS = sampler_state {
    texture = <ScnMapColS>;
#if J_FLAG
    MinFilter = LINEAR;
    MagFilter = LINEAR;
#else
    MinFilter = POINT;
    MagFilter = POINT;
#endif
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    string Format = "D24S8";
>;

// ֊s摜L^邽߂̃_[^[Qbg
texture2D ScnMapLine : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 1;
    string Format = "A8R8G8B8" ;
>;
sampler2D ScnSampLine = sampler_state {
    texture = <ScnMapLine>;
#if J_FLAG
    MinFilter = LINEAR;
    MagFilter = LINEAR;
#else
    MinFilter = POINT;
    MagFilter = POINT;
#endif
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};



////////////////////////////////////////////////////////////////////////////////////////////////

struct VS_OUTPUT{
	float4 Pos : POSITION;
	float2 Tex : TEXCOORD0;
};

////////////////////////////////////////////////////////////////////////////////////////////////
// HSV

VS_OUTPUT VS_pass_RGBtoHSV( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ) {
    VS_OUTPUT Out = (VS_OUTPUT)0; 
    
    Out.Pos = Pos;
    Out.Tex = Tex + ScreenOffset;
    
    return Out;
}

float4 PS_pass_RGBtoHSV( float2 Tex: TEXCOORD0 ) : COLOR {   
	float4 Color;

	Color = tex2D(ScnSamp, Tex);

	float3	hsv = {0,0,0};
	{	// RGBtoHSV
		const float r060 =  60.0 / 360.0;
		const float r120 = 120.0 / 360.0;
		const float r240 = 240.0 / 360.0;
		float	dMax = max(max(Color.r, Color.g), Color.b);
		float	dMin = min(min(Color.r, Color.g), Color.b);
		if(dMax){
			float	dDiff = dMax - dMin;
			hsv.y = dDiff / dMax;
			hsv.z = dMax;

			if(dMax == Color.r)			hsv.x = r060 * (Color.g - Color.b) / dDiff;
			else if(dMax == Color.g)	hsv.x = r060 * (Color.b - Color.r) / dDiff + r120;
			else						hsv.x = r060 * (Color.r - Color.g) / dDiff + r240;
			if(hsv.x < 0)				hsv.x+= 1.0;
			if(hsv.x > 1)				hsv.x = frac(hsv.x);
		}
	}
	Color.rgb = hsv;

    return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// F

VS_OUTPUT VS_pass_HSVtoRGB( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ) {
    VS_OUTPUT Out = (VS_OUTPUT)0; 
    
    Out.Pos = Pos;
    Out.Tex = Tex + ScreenOffset;
    
    return Out;
}

float4 PS_pass_HSVtoRGB( float2 Tex: TEXCOORD0 ) : COLOR {   
	float4 Color;

	Color = tex2D(ScnSampHSV, Tex);

	float Cnt = ColorCount - SAFE;
	if(Cnt<=SAFE)	Cnt = SAFE;
	float Rate = (1.0 / Cnt);
	float Harf= Rate / 2.0;
	float Range = 1.0 - Rate;
	if(Range<=SAFE)	Range = SAFE;
	float3	hsv;
	// F
	hsv.x = Color.r;									// F͉ŕϊ
	hsv.y = floor(Color.g * Cnt) / Cnt / Range;			// ʓx͕ō킹
	hsv.z = floor((Color.b + Harf) * Cnt) / Cnt;		// x͖邳̒ō킹

	{	// HSVtoRGB
		if(hsv.y == 0.0){
			Color.rgb = hsv.z;
		}
		else{
			float	f, n;
			f = modf((hsv.x * 6), n);

			// FF
			float HCnt = Cnt;
			if(HCnt<=4.0)	HCnt = 4.0;
			f = round(f * HCnt) / HCnt;

			float4	d = {1.0, (1 - hsv.y), (1 - hsv.y * f), (1 - hsv.y * (1 - f))};
			d *= hsv.z;
			saturate(d);

			if(n==0)			Color.rgb = float3(d.x, d.w, d.y);
			else if(n==1)		Color.rgb = float3(d.z, d.x, d.y);
			else if(n==2)		Color.rgb = float3(d.y, d.x, d.w);
			else if(n==3)		Color.rgb = float3(d.y, d.z, d.x);
			else if(n==4)		Color.rgb = float3(d.w, d.y, d.x);
			else				Color.rgb = float3(d.x, d.y, d.z);
		}
	}

    return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
// ֊so

VS_OUTPUT VS_pass_Line( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ) {
    VS_OUTPUT Out = (VS_OUTPUT)0; 
    
    Out.Pos = Pos;
    Out.Tex = Tex + ScreenOffset;
    
    return Out;
}

float4 PS_pass_Line( float2 Tex: TEXCOORD0 ) : COLOR {   
	float4 hsv;
	float mono;

	// 
	hsv = tex2D(ScnSampHSV, Tex);									mono = (hsv.z < LINE_RANGE) ? 0 : 1;
	// ㉺E
	hsv = tex2D(ScnSampHSV, Tex + float2(-SampStep.x, 0			));	mono = (hsv.z < LINE_RANGE) ? 0 : mono;
	hsv = tex2D(ScnSampHSV, Tex + float2( SampStep.x, 0			));	mono = (hsv.z < LINE_RANGE) ? 0 : mono;
	hsv = tex2D(ScnSampHSV, Tex + float2( 0			,-SampStep.y));	mono = (hsv.z < LINE_RANGE) ? 0 : mono;
	hsv = tex2D(ScnSampHSV, Tex + float2( 0			, SampStep.y));	mono = (hsv.z < LINE_RANGE) ? 0 : mono;
	// ΂
	hsv = tex2D(ScnSampHSV, Tex + float2(-SampStep.x,-SampStep.y));	mono = (hsv.z < LINE_RANGE) ? 0 : mono;
	hsv = tex2D(ScnSampHSV, Tex + float2( SampStep.x, SampStep.y));	mono = (hsv.z < LINE_RANGE) ? 0 : mono;
	hsv = tex2D(ScnSampHSV, Tex + float2( SampStep.x,-SampStep.y));	mono = (hsv.z < LINE_RANGE) ? 0 : mono;
	hsv = tex2D(ScnSampHSV, Tex + float2(-SampStep.x, SampStep.y));	mono = (hsv.z < LINE_RANGE) ? 0 : mono;

	float4 Color;
	Color.rgb	= mono;
	Color.a		= 1.0;

    return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////

VS_OUTPUT VS_Screen( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ){
    VS_OUTPUT Out = (VS_OUTPUT)0; 

    Out.Pos = Pos;
    Out.Tex = Tex + ScreenOffset;

    return Out;
}

// sNZVF[_
float4 PS_Mosaic( float2 Tex :TEXCOORD0 ) : COLOR0 {
	float4 Color;

	#if(AUTO_FLG)
		// J
		float TgtLen = length(CameraPosition-World[3].xyz);
		float z = TgtLen*0.055;
		float2 DotSize2 = OutputScreenSize * z / (DOT_SIZE * MaterialDiffuse.a + SAFE);
	
		float2 tex_coord = floor( DotSize2 * Tex + 0.5f) / DotSize2;
	#else
		float2 tex_coord = floor( DotSize * Tex + 0.5f) / DotSize;
	#endif

	if(ColorCount<1.0){
		Color = tex2D(ScnSampLine, tex_coord);
	}
	else{
		// F摜
		Color = tex2D(ScnSampColS, tex_coord);

		// ֊sǉ
		float	LineColor;
		LineColor = tex2D(ScnSampLine, tex_coord).r;
		LineColor = lerp(LineColor, 1.0f, (1.0f-MaterialDiffuse.a) );
		Color.rgb *= LineColor;
	}


#if 0
	Color = tex2D(ScnSampLine, Tex);		// eXgp
#endif

    return Color;
}

technique MainTec  <
	string Script = 
	"RenderColorTarget0=ScnMap;"
		"RenderDepthStencilTarget=DepthBuffer;"
			"ClearSetColor=ClearColor;"
			"ClearSetDepth=ClearDepth;"
			"Clear=Color;"
			"Clear=Depth;"
		"ScriptExternal=Color;"

	"RenderColorTarget0=ScnMapHSV;"
		"RenderDepthStencilTarget=DepthBuffer;"
			"ClearSetColor=ClearColor;"
			"ClearSetDepth=ClearDepth;"
			"Clear=Color;"
			"Clear=Depth;"
		"Pass=RGBtoHSV_pass;"

	"RenderColorTarget0=ScnMapLine;"
		"RenderDepthStencilTarget=DepthBuffer;"
			"ClearSetColor=ClearColor;"
			"ClearSetDepth=ClearDepth;"
			"Clear=Color;"
			"Clear=Depth;"
		"Pass=Line_pass;"

	"RenderColorTarget0=ScnMapColS;"
		"RenderDepthStencilTarget=DepthBuffer;"
			"ClearSetColor=ClearColor;"
			"ClearSetDepth=ClearDepth;"
			"Clear=Color;"
			"Clear=Depth;"
		"Pass=HSVtoRGB_pass;"

	"RenderColorTarget0=;"
		"RenderDepthStencilTarget=;"
		"Pass=DrawScreen;"
    ;
> {
	pass RGBtoHSV_pass < string Script= "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_2_0 VS_pass_RGBtoHSV();
		PixelShader  = compile ps_2_0 PS_pass_RGBtoHSV();
	}
	pass HSVtoRGB_pass < string Script= "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_2_0 VS_pass_HSVtoRGB();
		PixelShader  = compile ps_2_0 PS_pass_HSVtoRGB();
	}

    pass Line_pass < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
		VertexShader = compile vs_2_0 VS_pass_Line();
		PixelShader  = compile ps_2_0 PS_pass_Line();
    }

	pass DrawScreen < string Script="Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_1_1 VS_Screen();
		PixelShader  = compile ps_2_0 PS_Mosaic();
	}
}

